<?php

namespace FiloBlu\OrderStatus\Setup;

use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\UpgradeDataInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;
/**
 * Class UpgradeData
 * @package FiloBlu\OrderStatus\Setup
 */
class UpgradeData implements UpgradeDataInterface {

    /**
     * @var \Magento\Sales\Model\Order\StatusFactory
     */
    protected $_statusFactory;

    /**
     * UpgradeData constructor.
     * @param \Magento\Sales\Model\Order\StatusFactory $statusFactory
     */
    public function __construct(
    \Magento\Sales\Model\Order\StatusFactory $statusFactory
    ) {
        $this->_statusFactory = $statusFactory;
    }

    /**
     * @param ModuleDataSetupInterface $setup
     * @param ModuleContextInterface $context
     */
    public function upgrade(ModuleDataSetupInterface $setup, ModuleContextInterface $context) {

        $setup->startSetup();

        if (version_compare($context->getVersion(), '2.2.0') < 0) {

            $manualReviewStatus = $this->_statusFactory->create();
            $manualReviewStatus->setData('status', 'manual_review');
            $manualReviewStatus->setData('label', 'Manual Review');
            $manualReviewStatus->save();
            $manualReviewStatus->assignState(\Magento\Sales\Model\Order::STATE_NEW, false, true);
        }

        if(version_compare($context->getVersion(), '2.3.0') < 0) {

            $manualReviewStatus = $this->_statusFactory->create();
            $manualReviewStatus->setData('status', 'failed_refund');
            $manualReviewStatus->setData('label', 'Failed Refund');
            $manualReviewStatus->save();
            $manualReviewStatus->assignState(\Magento\Sales\Model\Order::STATE_CLOSED, false, true);
        }

        if(version_compare($context->getVersion(), '2.3.2') < 0) {

            $manualReviewStatus = $this->_statusFactory->create();
            $manualReviewStatus->setData('status', 'partially_refunded');
            $manualReviewStatus->setData('label', 'Partially Refunded');
            $manualReviewStatus->save();
            $manualReviewStatus->assignState(\Magento\Sales\Model\Order::STATE_PROCESSING, false, true);
        }
        $setup->endSetup();
    }

}
